function varargout = adjustment(varargin)
% ADJUSTMENT M-file for adjustment.fig
%      ADJUSTMENT, by itself, creates a new ADJUSTMENT or raises the existing
%      singleton*.
%
%      H = ADJUSTMENT returns the handle to a new ADJUSTMENT or the handle to
%      the existing singleton*.
%
%      ADJUSTMENT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ADJUSTMENT.M with the given input arguments.
%
%      ADJUSTMENT('Property','Value',...) creates a new ADJUSTMENT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before adjustment_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to adjustment_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help adjustment

% Last Modified by GUIDE v2.5 11-Feb-2012 12:25:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @adjustment_OpeningFcn, ...
                   'gui_OutputFcn',  @adjustment_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before adjustment is made visible.
function adjustment_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to adjustment (see VARARGIN)

% Choose default command line output for adjustment
handles.output = hObject;

% Handles, receiving data from main GUI
handles_mainGui = getappdata(0,'handles_mainGui');
input_data = getappdata(handles_mainGui, 'input_data');
handles.displacement = input_data(:,1);
handles.force = input_data(:,2);

% plotting the original diagram
plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)

% plotting the "30% of maximum load line"
plot_horizontal(handles.displacement, handles.force, handles.axes1)

% initialization of "reduction boundary line"
d_force = diff(handles.force)./diff(handles.displacement);
dd_force = diff(d_force)./diff(handles.displacement(1:end-1));

handles.tracker = 0;
i = 1;
while handles.tracker == 0;
    i = i+1;
    if dd_force(i+1) > dd_force(i) && dd_force(i) > dd_force(i-1)
        handles.tracker = i;
    end
end
plot_line(handles.tracker, handles.displacement, handles.force, handles.axes1)

% icons on buttons
checkedImage = importdata('checked.jpg');
set(handles.pushbutton1,'CData',checkedImage);

bbImage = importdata('bb.jpg');
set(handles.pushbutton2,'CData',bbImage);
bImage = importdata('b.jpg');
set(handles.pushbutton3,'CData',bImage);
fImage = importdata('f.jpg');
set(handles.pushbutton4,'CData',fImage);
ffImage = importdata('ff.jpg');
set(handles.pushbutton5,'CData',ffImage);

guidata(hObject, handles);

% UIWAIT makes adjustment wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = adjustment_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
handles_updateAxes = getappdata(handles_mainGui, 'handles_updateAxes');

input_data = [handles.displacement, handles.force]; 
setappdata(handles_mainGui, 'input_data', input_data)
feval(handles_updateAxes);
close

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.tracker = max(handles.tracker - 10, 0);
plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)
plot_horizontal(handles.displacement, handles.force, handles.axes1)
plot_line(handles.tracker, handles.displacement, handles.force, handles.axes1)
guidata(hObject, handles);

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.tracker = max(handles.tracker - 1, 0);
plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)
plot_horizontal(handles.displacement, handles.force, handles.axes1)
plot_line(handles.tracker, handles.displacement, handles.force, handles.axes1)
guidata(hObject, handles);

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.tracker = max(handles.tracker + 1, max(handles.displacement));
plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)
plot_horizontal(handles.displacement, handles.force, handles.axes1)
plot_line(handles.tracker, handles.displacement, handles.force, handles.axes1)
guidata(hObject, handles);

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.tracker = max(handles.tracker + 10, max(handles.displacement));
plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)
plot_horizontal(handles.displacement, handles.force, handles.axes1)
plot_line(handles.tracker, handles.displacement, handles.force, handles.axes1)
guidata(hObject, handles);

% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)
plot_horizontal(handles.displacement, handles.force, handles.axes1)

tangents = diff(handles.force);
tangents2 = zeros(6,1);
counter = 0;
for j = handles.tracker : handles.tracker + 5
    counter = counter+1;
    tangents2(counter) = tangents(j);
end
tangent = sum(tangents2)/size(tangents2,1);
forces = zeros(handles.tracker,1);
forces(end) = handles.force(handles.tracker);

for i = handles.tracker-1 : -1 : 1
    forces(i) = forces(i+1)-tangent;
end

handles.force(1:handles.tracker) = forces;
zero_pos = find(handles.force < 0);
first_pos = zero_pos(end);

handles.force(first_pos) = 0;
handles.force = handles.force(first_pos:end);

displ_shift = handles.displacement(first_pos);
handles.displacement = handles.displacement(first_pos:end);
newSize = size(handles.displacement);
handles.displacement = handles.displacement-displ_shift*ones(newSize,1);

plot_forceDisplacement2(handles.displacement, handles.force, handles.axes1);
clc
guidata(hObject, handles);


%% My functions
function plot_forceDisplacement(displacement, force, handles_axes)
plot(handles_axes, displacement, force)
hold on

function plot_line(tracker, displacement, force, handles_axes)
tracker_x = [displacement(tracker+1), displacement(tracker+1)];
tracker_y = [0, 1.1*max(force)];
plot(handles_axes, tracker_x, tracker_y, '-r')
hold off

function plot_horizontal(displacement, force, handles_axes)
position_x = [min(displacement), max(displacement)];
position_y = [0.3*max(force), 0.3*max(force)];
plot(handles_axes, position_x, position_y, '--k','LineWidth',2)
text(max(displacement), 0.3*max(force),'30 % of maximum load','HorizontalAlignment','right','VerticalAlignment','bottom')
hold on

function plot_forceDisplacement2(displacement, force, handles_axes)
plot(handles_axes, displacement, force, '-r', 'LineWidth',2)

