%% Script providing an imput for the program (reads the file and extract the data
% output: handles.input_data = matrix having one column as displacements
%         and second column as corresponding forces from a measurement

forcesColumn = 1;           % in what column in input file we can find the forces
displacementsColumn = 3;    % in what column in input file we can find the displacements

size = 0;
notNumbers = [];
total = 0;
fid = fopen([input_path input_filename]);       % opens the file

%% Find not numbers
while feof(fid) == 0                    % repeat until the end of the input file
    total = total+1;
    lineContent = fgetl(fid);
    if isempty(lineContent)
        notNumbers = [notNumbers, total];
    end
    if ~isempty(lineContent)
        numberCheck = str2num(lineContent(1));
        if isempty(numberCheck)
            notNumbers = [notNumbers, total];
        end        
    end
end

%% Extract numbers
counter = 0;
firstNum = 0;
lastNum = 0;

while firstNum == 0
    counter = counter+1;
    if notNumbers(counter) ~= notNumbers(counter+1)-1
        firstNum = notNumbers(counter)+1;
    end
end

counter = length(notNumbers);
while lastNum == 0
    counter = counter-1;
    if notNumbers(counter) ~= notNumbers(counter-1)+1
        lastNum = notNumbers(counter)-1;
    end 
end

fclose(fid); % closes the file

%% Make vectors with values

fid = fopen([input_path input_filename]);       % re-opens the file

numberLines = lastNum-firstNum+1;
forces = zeros(numberLines,1);
displacements  = zeros(numberLines,1);
structure(numberLines).data = '';

counter = 0;
counter2 = 0;
while feof(fid) == 0                    % repeat until the end of the input file
    counter = counter+1;
    lineContent = fgetl(fid);
    if counter >= firstNum && counter <= lastNum
        counter2 = counter2+1;
        structure(counter2).data = lineContent;
    end    
end

a = eval(['[',structure(1).data,']']);
dataInVectors = zeros(numberLines,length(a));

for i = 1:numberLines
    dataInVectors(i,:) = eval(['[',structure(i).data,']']);
    forces(i) = dataInVectors(i,forcesColumn);
    displacements(i) = dataInVectors(i,displacementsColumn);
end

resultsIntoMatrix = [displacements/1000,forces];
fclose(fid);


handles.input_data = resultsIntoMatrix;