function varargout = main(varargin)
% MAIN M-file for main.fig
%      MAIN, by itself, creates a new MAIN or raises the existing
%      singleton*.
%
%      H = MAIN returns the handle to a new MAIN or the handle to
%      the existing singleton*.
%
%      MAIN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MAIN.M with the given input arguments.
%
%      MAIN('Property','Value',...) creates a new MAIN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before main_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to main_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help main

% Last Modified by GUIDE v2.5 25-Feb-2012 21:19:40

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @main_OpeningFcn, ...
                   'gui_OutputFcn',  @main_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_Singleton, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before main is made visible.
function main_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to main (see VARARGIN)

% Choose default command line output for main
handles.output = hObject;

% save handles to mainGui and functions into root memory
setappdata(0,'handles_mainGui',gcf)                 % get handles to main GUI
setappdata(gcf, 'handles_updateAxes', @updateAxes)  % get handles to updateAxes function

% addpath to files
addpath(fullfile(pwd,'files'))
addpath(fullfile(pwd,['files' filesep 'pics']))
addpath(fullfile(pwd,['files' filesep 'gui_files']))
addpath(fullfile(pwd,'functions'))
addpath(fullfile(pwd,'input'))
addpath(fullfile(pwd,'output'))
addpath(fullfile(pwd,['output' filesep 'aux_data']))

% set icons to buttons
logoImage = importdata('logo.jpg'); 
axes(handles.axes1)                 % select the axes
image(logoImage)                    % place image onto the axes
axis off                            % remove the axis tick marks

infoImage = importdata('info.jpg');
set(handles.pushbutton5,'CData',infoImage);
exitImage = importdata('exit.jpg');
set(handles.pushbutton6,'CData',exitImage);

set(handles.pushbutton3,'Enable', 'off')
set(handles.pushbutton2,'Enable', 'off')
set(handles.pushbutton9,'Enable', 'off')
set(handles.pushbutton10,'Enable', 'off')
set(handles.pushbutton7,'Enable', 'off')
set(handles.pushbutton11,'Enable', 'off')

handles.switch_diagram = 1;
handles_mainGui = getappdata(0,'handles_mainGui');
setappdata(handles_mainGui, 'switch_diagram', handles.switch_diagram)

guidata(hObject, handles);
setappdata(handles_mainGui, 'textbox', handles.text2)
% UIWAIT makes main wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = main_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

run input_menu

set(handles.pushbutton2,'Enable', 'on')
set(handles.pushbutton9,'Enable', 'on')
set(handles.pushbutton7,'Enable', 'on')


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

run adjustment

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

run results

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

msgbox({'The program is pretty straighforward, just read the tags on the buttons',...
    ' ','It was created by Vaclav Nezerka, 2012.',' ',... 
    'The input files have to be in ASCII format, preferably *.txt or *.dat,'...
    ' and have a certain structure (see .../input/sample.txt)',' ',...
    'For postprocessing it is important to choose more than one file, otherwise the postprocessing does not start.',' ',...
    'If you encounter any bugs or have a question, please contact me at nezerka.v@seznam.cz'},...
    'About the program','help');

% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

clc
clear all
close all

% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles) 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h = figure;
set(h,'Position',[100 100 750 650])

handles_mainGui = getappdata(0,'handles_mainGui');
handles_axes = findobj(handles_mainGui, 'type', 'axes');
copyobj(handles_axes(2),h);

% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.pushbutton3,'Enable', 'on')
set(handles.pushbutton10,'Enable', 'on')
set(handles.pushbutton11,'Enable', 'on')
run elastic_part

% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if handles.switch_diagram == 1
    set(handles.pushbutton10,'String', '<<   switch to force - displ. diagram')
    handles.switch_diagram = 2;
    handles_mainGui = getappdata(0,'handles_mainGui');
    setappdata(handles_mainGui, 'switch_diagram', handles.switch_diagram);
    updateAxes
else
    set(handles.pushbutton10,'String', '<<   switch to stress - strain diagram')
    handles.switch_diagram = 1;
    handles_mainGui = getappdata(0,'handles_mainGui');
    setappdata(handles_mainGui, 'switch_diagram', handles.switch_diagram);
    updateAxes
end

guidata(hObject, handles);

% --- Executes on button press in pushbutton11.
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

run calculate_properties

output = zeros(size(stress,1),4);
output(:,1) = [force;force(end);force(end)];
output(:,2) = [displacement;displacement(end);displacement(end)];
output(:,3) = stress;
output(:,4) = strain;
    
aux_data = zeros(6,1);
aux_data(1) = maximum_force;             % save max force [N]
aux_data(2) = disp_at_max*1e3;          % save displacement at max [mm]
aux_data(3) = maximum_stress/1e6;        % save max stress [MPa]
aux_data(4) = strain_at_max;             % save strain at max [-]
aux_data(5) = E/1e6;                     % save Young's modulus [MPa]
aux_data(6) = Gf;                        % save max displacement [J/m^2]

current_folder = pwd;
open_folder = [current_folder filesep 'output'];
output_filename = getappdata(handles_mainGui, 'input_filename');
path = [open_folder filesep output_filename];
path2 = [open_folder filesep 'aux_data' filesep output_filename];

dlmwrite(path, output, 'newline', 'pc')
dlmwrite(path2, aux_data, 'newline', 'pc')
msgbox('The data were successfully saved.','Process info');
clc


% --- Executes on button press in pushbutton12.
function pushbutton12_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

current_folder = pwd;
open_folder = [current_folder filesep 'output'];
[input_filename, input_path] = ...
     uigetfile({'*.txt';'*.tex';'*.dat';'*.*'},...
     'MultiSelect', 'on',...
     'File Selector',open_folder);
 
rowHeaders = strrep(input_filename, '.txt', '');

nF = size(input_filename,2);
postprocess.nF = nF;

postprocess(nF).files = '';
postprocess(nF).files_aux = '';
for i = 1:nF
    file = char(input_filename(i));
    postprocess(i).files = [input_path file];
    postprocess(i).files_aux = [input_path 'aux_data' filesep file];
end

postprocess(nF).data = '';
for i = 1:nF
    postprocess(i).data = load(postprocess(i).files);
end

postprocess(nF).aux_data = '';
for i = 1:nF
    postprocess(i).aux_data = load(postprocess(i).files_aux);
end

postprocess(nF).names = '';
for i = 1:nF
    file = char(input_filename(i));
    postprocess(i).names = file(1:(end-4));
end

handles_mainGui = getappdata(0,'handles_mainGui');
setappdata(handles_mainGui, 'postprocess', postprocess);
setappdata(handles_mainGui, 'rowHeaders', rowHeaders);
run postprocessing

function updateAxes

handles_mainGui = getappdata(0,'handles_mainGui');
handles_axes = findobj(handles_mainGui, 'type', 'axes');
input_data = getappdata(handles_mainGui, 'input_data');

l = getappdata(handles_mainGui, 'length');
w = getappdata(handles_mainGui, 'width');
h = getappdata(handles_mainGui, 'height');
a = getappdata(handles_mainGui, 'notch');
rho = getappdata(handles_mainGui, 'density');
l_tot = getappdata(handles_mainGui, 'tot_length');
wa = getappdata(handles_mainGui, 'notch_width');
heff = h-a;

handles.displacement = input_data(:,1);
handles.force = input_data(:,2);

handles.switch_diagram = getappdata(handles_mainGui, 'switch_diagram');

if handles.switch_diagram == 1
    plot(handles_axes(2),handles.displacement*1e3, handles.force)
    set(get(handles_axes(2),'YLabel'),'String','force  (F) [N]','FontSize',14)
    set(get(handles_axes(2),'XLabel'),'String','displacement  (\delta) [mm]','FontSize',14)
    
    textbox = getappdata(handles_mainGui, 'textbox');
    set(textbox, 'String',...
        'NOTE: self-weight IS NOT included in the force - displacement diagram')
    clc
else
    k = getappdata(handles_mainGui, 'beam_stiffness');
    E = f_notched_beam_stiffness2(k,w,h,a,wa,l);
    stress_sw = rho*w*h*(l^2-(l_tot-l)^2)*3/(4*w*heff^2);    % stress from self-weight
    strain_sw = stress_sw/E;                                 % strain from self-weight
    
    handles.strain = [0; 
                      strain_sw;
                      ones(size(handles.displacement),1)*strain_sw+...
                                handles.displacement*6*heff/(l^2)];
    handles.stress = [0; 
                      stress_sw;
                      ones(size(handles.force),1)*stress_sw+...
                                handles.force*3*l/(2*w*heff^2)]/1e6;
                  
    plot(handles_axes(2),handles.strain, handles.stress)
    set(get(handles_axes(2),'YLabel'),'String','stress  (\sigma) [MPa]','FontSize',14)
    set(get(handles_axes(2),'XLabel'),'String','strain  (\epsilon) [-]','FontSize',14)
    
    textbox = getappdata(handles_mainGui, 'textbox');
    set(textbox, 'String',...
        'NOTE: self-weight IS included in the digram, the softening part is NOT true')
    clc
end

